#!/bin/bash

# After running the WETProcessor on warc.wet(.gz) files
# to create keepURLs.txt and discardURLs.txt, run this script on keepURLs.txt
# RUN AS:
# ./bin/script/unique_mri_domains_from_cc.sh tmp/processedWET/keepURLs.txt

# https://stackoverflow.com/questions/4651437/how-do-i-set-a-variable-to-the-output-of-a-command-in-bash

infile=$1
prev_glued_together=

# "The sort -u command removes duplicates"
# see http://pages.di.unipi.it/corradini/Didattica/AP-17/DOCS/Scott-ch13.pdf
<$1 sort -u > sorted_MRI_urls.txt


while read url; do
    line=$url

    # Extract 3rd field of each url, where delimiter is /. So http:// counts as the first and second. Then third field follows up to next /.
    line="$(echo $line | cut -d/ -f3)"

    
    #    line="$(echo $line | cut -d ' ' -f4)"

    # remove optional www. at start
    # and turn urls like "massey.ac.nz." into "massey.ac.nz"   
    # https://stackoverflow.com/questions/16623835/remove-a-fixed-prefix-suffix-from-a-string-in-bash
    line=${line#"www."}
#    line=${line%"."}
#    line=${line%"\","}
    #echo $line
    
    # In order to test subdomains, first remove period marks
    # https://stackoverflow.com/questions/13210880/replace-one-substring-for-another-string-in-shell-script
    glued_together=${line//\./}
    #echo $glued_together
    # check if this line is a 'suffix' of the previous one
    if [ -z $prev_glued_together ]; then
	echo "$line"
	# found the first domain, store as previous one
	prev_glued_together=$glued_together
	echo $url >> uniq_mri_urls.txt
    else
	#echo "> Previous: $prev_glued_together"
	#echo "> Current: $glued_together"
	
	# if [[ $glued_together = *$prev_glued_together ]]; then
	#     echo "X$line"
	# elif [[ $prev_glued_together = *$glued_together ]]; then
	#     # check if prev line is a 'suffix' of this one
	#     echo "XX$line"
	# else
	#     echo "$line"
	# fi
#	if [[ $glued_together != *$prev_glued_together && $prev_glued_together != *$glued_together ]]; then
	if [[ $glued_together != $prev_glued_together* && $prev_glued_together != $glued_together* ]]; then	    
	    echo "Selecting: $line"
	    # found a new domain, store as previous one
	    prev_glued_together=$glued_together

	    # write uniq url to file
	    echo $url >> uniq_mri_urls.txt
	fi
    fi
    
    
done < <(cat sorted_MRI_urls.txt) 

echo "**************************************"
count=`wc -l $1`
echo "Number of URLs in INPUT FILE: $count" # $1
count=`wc -l sorted_MRI_urls.txt`
echo "Number of URLs in intermediate unique sorted file: $count" #sorted_MRI_urls.txt
count=`wc -l uniq_mri_urls.txt`
echo "Number of URLs of unique domains in OUTPUT FILE: $count" #uniq_mri_urls.txt
echo "**************************************"
# remove intermediate file
rm sorted_MRI_urls.txt
